// Copyright (C) 2003, 2005 Daisuke Arai <darai@users.sourceforge.jp>
// Copyright (C) 2013 panacoran <panacoran@users.sourceforge.jp>
// 
// This program is part of Protra.
//
// Protra is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
// 
// $Id: IfStatementNode.cs 472 2013-06-26 15:26:49Z panacoran $

using System.Collections.Generic;

namespace Protra.Lib.Lang
{
    /// <summary>
    /// if文のノードを表すクラス。
    /// </summary>
    public class IfStatementNode : ExecutableNode
    {
        /// <summary>
        /// 条件式のノード
        /// </summary>
        private ExpressionNode _condNode;

        /// <summary>
        /// ノードのリスト
        /// </summary>
        private readonly List<ExecutableNode> _nodeList = new List<ExecutableNode>();

        /// <summary>
        /// 次のelsif句またはelse句
        /// </summary>
        private IfStatementNode _nextNode;

        /// <summary>
        /// 構文解析する。
        /// </summary>
        /// <exception cref="Protra.Lib.Lang.ParseException">
        /// 構文解析中にエラーが発生したときにthrowされる。
        /// </exception>
        /// <return>
        /// 解析した結果のノード。
        /// </return>
        public override ExecutableNode Parse(Scanner scanner)
        {
            Token = scanner.Token;

            if (!scanner.Scan())
                throw new ParseException("expression is expected", Token);
            _condNode = new ExpressionNode().Parse(scanner);
            if (scanner.Token.Value != ";")
                throw new ParseException("';' expected", Token);

            while (scanner.Scan())
            {
                var token = scanner.Token.Value;
                if (token == "end")
                {
                    scanner.Scan();
                    if (scanner.Token.Value != ";")
                        throw new ParseException("';' expected", scanner.Token);
                    return this;
                }
                if (token == "elsif")
                {
                    _nextNode = (IfStatementNode)(new IfStatementNode().Parse(scanner));
                    return this;
                }
                if (token == "else")
                {
                    _nextNode = ParseElse(scanner);
                    return this;
                }
                _nodeList.Add(new StatementNode().Parse(scanner));
            }
            throw new ParseException("unexpected EOF", Token);
        }

        private IfStatementNode ParseElse(Scanner scanner)
        {
            scanner.Scan();
            if (scanner.Token.Value != ";")
                throw new ParseException("';' expected", scanner.Token);

            var node = new IfStatementNode {_condNode = new LiteralNode(new Value(true))};
            while (scanner.Scan())
            {
                if (scanner.Token.Value == "end")
                {
                    scanner.Scan();
                    if (scanner.Token.Value != ";")
                        throw new ParseException("';' expected", scanner.Token);
                    return node;
                }
                node._nodeList.Add(new StatementNode().Parse(scanner));
            }
            throw new ParseException("unexpected EOF", Token);
        }

        /// <summary>
        /// プログラムを実行する。
        /// </summary>
        /// <exception cref="Protra.Lib.Lang.RuntimeException">
        /// プログラム実行中にエラーが発生した場合にthrowされる。
        /// </exception>
        /// <param name="resource">リソース</param>
        /// <param name="at">int型@作用素の値</param>
        /// <param name="ats">string型@作用素の値</param>
        /// <returns>実行結果</returns>
        public override Result Execute(Resource resource, int at, string ats)
        {
            var val = _condNode.Evaluate(resource, at, ats);
            if (val != null && val.IsTrue)
                foreach (var node in _nodeList)
                {
                    var result = node.Execute(resource, at, ats);
                    if (result != Result.Normal)
                        return result;
                }
            else if (_nextNode != null)
                return _nextNode.Execute(resource, at, ats);
            return Result.Normal;
        }
    }
}